/**
 * The Readonly decorator. The field is readonly in the form. It just renders grayed out
 * and handles the internals using default HTML5 techniques.
 *
 *
 * @param readonly      Optional, default is true.
 * @param description   A tooltip that can be used optionally.
 */
/**
 * The Readonly decorator. The field is readonly in the form. It just renders grayed out
 * and handles the internals using default HTML5 techniques.
 *
 *
 * @param readonly      Optional, default is true.
 * @param description   A tooltip that can be used optionally.
 */ export function Readonly(readonly) {
    if (readonly === void 0) { readonly = true; }
    // the original decorator
    function readonlyInternal(target, property) {
        readonlyInternalSetup(target, property.toString(), readonly);
    }
    // return the decorator
    return readonlyInternal;
}
export function readonlyInternalSetup(target, key, readonly) {
    // create a helper property to transport a meta data value
    Object.defineProperty(target, "__isReadonly__" + key, {
        value: readonly,
        enumerable: false,
        configurable: false
    });
}

//# sourceMappingURL=hint-readonly.decorator.js.map
