/**
 * The compare decorator compares two field's values and
 * shows an error message on the decorated field. The other field (compared to) does
 * not has a decorator nor receives a message.
 *
 * @param withProperty: A string that represents the compared field's name.
 * @param msg: A custom message.
 *
 */
/**
 * The compare decorator compares two field's values and
 * shows an error message on the decorated field. The other field (compared to) does
 * not has a decorator nor receives a message.
 *
 * @param withProperty: A string that represents the compared field's name.
 * @param msg: A custom message.
 *
 */ export function Compare(withProperty, msg) {
    // the original decorator
    function compareInternal(target, property) {
        compareInternalSetup(target, property.toString(), withProperty, msg);
    }
    // return the decorator
    return compareInternal;
}
export function compareInternalSetup(target, key, withProperty, msg) {
    // create a helper property to transport a meta data value
    Object.defineProperty(target, "__hasCompareProperty__" + key, {
        value: true,
        enumerable: false,
        configurable: false
    });
    Object.defineProperty(target, "__withCompare__" + key, {
        value: withProperty,
        enumerable: false,
        configurable: false
    });
    Object.defineProperty(target, "__errCompareProperty__" + key, {
        value: msg
            || "The field " + key + " must have the same value as field " + withProperty,
        enumerable: false,
        configurable: false
    });
}

//# sourceMappingURL=val-compare.decorator.js.map
