/**
 * The decorator assures that a string field fullfilles a regular expression pattern.
 *
 * @param pattern: The expression as RegExp.
 * @param msg: A custom message.
 *
 */
/**
 * The decorator assures that a string field fullfilles a regular expression pattern.
 *
 * @param pattern: The expression as RegExp.
 * @param msg: A custom message.
 *
 */ export function Pattern(pattern, msg) {
    // the original decorator
    function patternInternal(target, property) {
        patternInternalSetup(target, property.toString(), pattern, msg);
    }
    // return the decorator
    return patternInternal;
}
export function patternInternalSetup(target, key, reg, msg) {
    // create a helper property to transport a meta data value
    Object.defineProperty(target, "__hasPattern__" + key, {
        value: reg,
        enumerable: false,
        configurable: false
    });
    Object.defineProperty(target, "__errPattern__" + key, {
        value: msg || "The field " + key + " must fullfill the pattern " + reg,
        enumerable: false,
        configurable: false
    });
}

//# sourceMappingURL=val-pattern.decorator.js.map
