/**
 * A custom validator to compare two fields. This is internally to support the infarstructure
 * and not intendet to being used by custom code.
 *
 * @param p The field's name
 *
 */
export function validateCompare(p) {
    var changeEventWasAdded = false;
    return function (c) {
        var form = c.root;
        if (form && form.controls && !changeEventWasAdded) {
            form.controls[p].valueChanges.subscribe(function () {
                // trigger validation for particular element
                c.updateValueAndValidity();
            });
            changeEventWasAdded = true;
        }
        if (c.value) {
            // compare the current value with the referenced control's value
            return (!c.value || c.value == c.root['controls'][p].value) ? null : {
                'compare': {
                    valid: false
                }
            };
        }
    };
}

//# sourceMappingURL=compare.validator.js.map
