/**
 * A custom validator to valdiate a range of numbers or dates. This is internally to support the infarstructure
 * and not intendet to being used by custom code.
 *
 * @param p The field's name
 *
 */
export function validateRange(f, t) {
    return function (c) {
        if ((Number(f) || Number(t)) && Number(c.value)) {
            var fr = Number(f);
            var to = Number(t);
            var v = Number(c.value);
            return (!fr || v >= fr) && (!to || v <= to) ? null : {
                'range': {
                    valid: false
                }
            };
        }
        if ((Date.parse(f.toString()) || Date.parse(t.toString())) && Date.parse(c.value)) {
            var fr = Date.parse(f.toString());
            var to = Date.parse(t.toString());
            var v = Date.parse(c.value);
            return (!fr || v >= fr) && (!to || v <= to) ? null : {
                'range': {
                    valid: false
                }
            };
        }
    };
}

//# sourceMappingURL=range.validator.js.map
